<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>polylib: ehrhart_lower_bound.c Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.6 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
<h1>ehrhart_lower_bound.c</h1><a href="ehrhart__lower__bound_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00002"></a>00002 <span class="preprocessor">#include &lt;string.h&gt;</span>
<a name="l00003"></a>00003 <span class="preprocessor">#include &lt;stdlib.h&gt;</span>
<a name="l00004"></a>00004 
<a name="l00005"></a>00005 <span class="preprocessor">#include &lt;<a class="code" href="polylib_8h.html">polylib/polylib.h</a>&gt;</span>
<a name="l00006"></a>00006 
<a name="l00007"></a>00007 
<a name="l00008"></a><a class="code" href="ehrhart__lower__bound_8c.html#3c04138a5bfe5d72780bb7e82a18e627">00008</a> <span class="keywordtype">int</span> <a class="code" href="c2p_8c.html#e66f6b31b5ad750f1fe042a706a4e3d4">main</a>( <span class="keywordtype">int</span> argc, <span class="keywordtype">char</span> **argv)
<a name="l00009"></a>00009 {
<a name="l00010"></a>00010   <span class="keywordtype">int</span> i;
<a name="l00011"></a>00011   <span class="keyword">const</span> <span class="keywordtype">char</span> **param_name;
<a name="l00012"></a>00012   <a class="code" href="structmatrix.html">Matrix</a> *C1, *P1;
<a name="l00013"></a>00013   <a class="code" href="structpolyhedron.html">Polyhedron</a> *P, *C;
<a name="l00014"></a>00014   <a class="code" href="struct__enumeration.html">Enumeration</a> *e, *en;
<a name="l00015"></a>00015 
<a name="l00016"></a>00016   <a class="code" href="structmatrix.html">Matrix</a> * Validity_Lattice;
<a name="l00017"></a>00017   <span class="keywordtype">int</span> nb_parms;
<a name="l00018"></a>00018   
<a name="l00019"></a>00019 <span class="preprocessor">#ifdef EP_EVALUATION</span>
<a name="l00020"></a>00020 <span class="preprocessor"></span>  Value *<a class="code" href="vector_8c.html#a45b2e3dcf291527c5aedc420819adfc">p</a>, *tmp;
<a name="l00021"></a>00021   <span class="keywordtype">int</span> k;
<a name="l00022"></a>00022 <span class="preprocessor">#endif</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024   P1 = <a class="code" href="matrix_8c.html#3a087ae9a03d5baf0b81831177931143">Matrix_Read</a>();
<a name="l00025"></a>00025   C1 = <a class="code" href="matrix_8c.html#3a087ae9a03d5baf0b81831177931143">Matrix_Read</a>();
<a name="l00026"></a>00026   nb_parms = C1-&gt;<a class="code" href="structmatrix.html#68858fd3b57684ef38bdfce13c65d182">NbColumns</a>-2;
<a name="l00027"></a>00027   <span class="keywordflow">if</span>(nb_parms &lt; 0) {
<a name="l00028"></a>00028     fprintf( stderr, <span class="stringliteral">"Not enough parameters !\n"</span> );
<a name="l00029"></a>00029     exit(0);
<a name="l00030"></a>00030   }
<a name="l00031"></a>00031 
<a name="l00032"></a>00032    <span class="comment">/* Read the name of the parameters */</span>
<a name="l00033"></a>00033   param_name = <a class="code" href="param_8c.html#c5f556f34173ebc8815247ee7f4e2a0b">Read_ParamNames</a>(stdin,nb_parms);
<a name="l00034"></a>00034 
<a name="l00035"></a>00035   <span class="comment">/* inflate the polyhedron, so that the inflated EP approximation will be an</span>
<a name="l00036"></a>00036 <span class="comment">     upper bound for the EP's polyhedron. */</span>
<a name="l00037"></a>00037   <a class="code" href="matrix__addon_8c.html#0f0ba73176f5316a02e849b8c210204a" title="deflates a polyhedron (represented as a matrix) P, so that the apx of its Ehrhart...">mpolyhedron_deflate</a>(P1,nb_parms);
<a name="l00038"></a>00038 
<a name="l00039"></a>00039   <span class="comment">/* compute a polynomial approximation of the Ehrhart polynomial */</span>
<a name="l00040"></a>00040   e = <a class="code" href="ehrhart_8c.html#0d3e40195e67384f3655c772212ed1d5" title="Computes the approximation of the Ehrhart polynomial of a polyhedron (implicit form...">Ehrhart_Quick_Apx</a>(P1, C1, &amp;Validity_Lattice, 1024);
<a name="l00041"></a>00041   
<a name="l00042"></a>00042   <a class="code" href="matrix_8c.html#fcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(C1);
<a name="l00043"></a>00043   <a class="code" href="matrix_8c.html#fcb312b7c12a6997cd66964ecc34e1a6">Matrix_Free</a>(P1);
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   printf(<span class="stringliteral">"============ Ehrhart polynomial quick polynomial lower bound ============\n"</span>);
<a name="l00046"></a>00046   <a class="code" href="matrix__addon_8h.html#11468159c7fa7d75fadfa10e2e929fee" title="Polylib matrix addons Mainly, deals with polyhedra represented in implicit form (set...">show_matrix</a>(Validity_Lattice);
<a name="l00047"></a>00047   <span class="keywordflow">for</span>( en=e ; en ; en=en-&gt;<a class="code" href="struct__enumeration.html#d2fd42474e015c9abc6aea0e2bea08b8">next</a> ) {    
<a name="l00048"></a>00048     <a class="code" href="polyparam_8c.html#fa315bc856959f9a781359f69b74d7a4">Print_Domain</a>(stdout,en-&gt;<a class="code" href="struct__enumeration.html#57e35419d63ab12898542ef58d8decac">ValidityDomain</a>, param_name);
<a name="l00049"></a>00049     <a class="code" href="ehrhart_8c.html#99718adf05e065181f35f5ca847f94b0">print_evalue</a>(stdout,&amp;en-&gt;<a class="code" href="struct__enumeration.html#a499b062a10ce16356e9b52d25cae0d9">EP</a>, param_name);
<a name="l00050"></a>00050     printf( <span class="stringliteral">"\n-----------------------------------\n"</span> );
<a name="l00051"></a>00051   }
<a name="l00052"></a>00052  
<a name="l00053"></a>00053 <span class="preprocessor">#ifdef EP_EVALUATION</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span>  <span class="keywordflow">if</span>( isatty(0) &amp;&amp; nb_parms != 0)
<a name="l00055"></a>00055   {  <span class="comment">/* no tty input or no polyhedron -&gt; no evaluation. */</span>
<a name="l00056"></a>00056     printf(<span class="stringliteral">"Evaluation of the Ehrhart polynomial :\n"</span>);
<a name="l00057"></a>00057     p = (Value *)malloc(<span class="keyword">sizeof</span>(Value) * (nb_parms));
<a name="l00058"></a>00058     <span class="keywordflow">for</span>(i=0;i&lt;nb_parms;i++) 
<a name="l00059"></a>00059       <a class="code" href="source_2arith_2arithmetique_8h.html#f71a2ca0294a19cff0cdcbdcc052ee27">value_init</a>(p[i]);
<a name="l00060"></a>00060     <a class="code" href="types_8h.html#75c828ed6c02fcd44084e67a032e422c">FOREVER</a> {
<a name="l00061"></a>00061       fflush(stdin);
<a name="l00062"></a>00062       printf(<span class="stringliteral">"Enter %d parameters : "</span>,nb_parms);
<a name="l00063"></a>00063       <span class="keywordflow">for</span>(k=0;k&lt;nb_parms;++k) {
<a name="l00064"></a>00064         scanf(<span class="stringliteral">"%s"</span>,str);
<a name="l00065"></a>00065         <a class="code" href="source_2arith_2arithmetique_8h.html#b8a77ddf3765fd598f31d8ca2ac4705c">value_read</a>(p[k],str);
<a name="l00066"></a>00066       }
<a name="l00067"></a>00067       fprintf(stdout,<span class="stringliteral">"EP( "</span>);
<a name="l00068"></a>00068       <a class="code" href="source_2arith_2arithmetique_8h.html#d34605b56b571830b928b50a74d618b7">value_print</a>(stdout,VALUE_FMT,p[0]);
<a name="l00069"></a>00069       <span class="keywordflow">for</span>(k=1;k&lt;nb_parms;++k) {
<a name="l00070"></a>00070         fprintf(stdout,<span class="stringliteral">","</span>);
<a name="l00071"></a>00071         <a class="code" href="source_2arith_2arithmetique_8h.html#d34605b56b571830b928b50a74d618b7">value_print</a>(stdout,VALUE_FMT,p[k]);
<a name="l00072"></a>00072       }
<a name="l00073"></a>00073       fprintf(stdout,<span class="stringliteral">" ) = "</span>);
<a name="l00074"></a>00074       <a class="code" href="source_2arith_2arithmetique_8h.html#d34605b56b571830b928b50a74d618b7">value_print</a>(stdout,VALUE_FMT,*(tmp=<a class="code" href="eval__ehrhart_8c.html#f970e7f69cbf548188a8f3754001a150">compute_poly</a>(en,p)));
<a name="l00075"></a>00075       free(tmp);
<a name="l00076"></a>00076       fprintf(stdout,<span class="stringliteral">"\n"</span>);  
<a name="l00077"></a>00077     }
<a name="l00078"></a>00078   }
<a name="l00079"></a>00079 <span class="preprocessor">#endif </span><span class="comment">/* EP_EVALUATION */</span>
<a name="l00080"></a>00080   
<a name="l00081"></a>00081   <span class="keywordflow">while</span>( e )
<a name="l00082"></a>00082     {
<a name="l00083"></a>00083       <a class="code" href="ehrhart_8c.html#96434ed8279f7999773fa3343cfe98b8" title="releases all memory referenced by e.">free_evalue_refs</a>( &amp;(e-&gt;<a class="code" href="struct__enumeration.html#a499b062a10ce16356e9b52d25cae0d9">EP</a>) );
<a name="l00084"></a>00084       <a class="code" href="polyhedron_8c.html#4ae97b9794e3a616f1d38c68e6515cc3">Polyhedron_Free</a>( e-&gt;<a class="code" href="struct__enumeration.html#57e35419d63ab12898542ef58d8decac">ValidityDomain</a> );
<a name="l00085"></a>00085       en = e -&gt;<a class="code" href="struct__enumeration.html#d2fd42474e015c9abc6aea0e2bea08b8">next</a>;
<a name="l00086"></a>00086       free( e );
<a name="l00087"></a>00087       e = en;
<a name="l00088"></a>00088     }
<a name="l00089"></a>00089   <a class="code" href="param_8c.html#e85c395031b2feb7cc47ba691bb6392f">Free_ParamNames</a>(param_name, nb_parms);
<a name="l00090"></a>00090   <span class="keywordflow">return</span> 0;
<a name="l00091"></a>00091 }
</pre></div></div>
<hr size="1"><address style="text-align: right;"><small>Generated on Tue Sep 15 18:33:59 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.6 </small></address>
</body>
</html>
